import os

# Pobieranie nazwy projektu od użytkownika
nazwa_projektu = input("Podaj nazwę projektu Laravel: ")

if os.system("command -v composer &> /dev/null\n") != 0:
    print("Composer nie jest zainstalowany. Proszę zainstalować go przed uruchomieniem skryptu.\n")
    exit(1)

if os.system("command -v npm &> /dev/null\n") != 0:
    print("npm nie jest zainstalowane. Proszę zainstalować je przed uruchomieniem skryptu.")
    exit(1)

# Tworzenie nowego projektu Laravel
os.system(f"composer create-project --prefer-dist laravel/laravel {nazwa_projektu}")

# Przechodzenie do katalogu projektu
os.chdir(nazwa_projektu)

# Instalacja Tailwind CSS
os.system("npm install -D tailwindcss postcss autoprefixer")

# Inicjalizacja pliku konfiguracyjnego Tailwind CSS
os.system("npx tailwindcss init -p")

# Konfiguracja ścieżek do plików szablonów w tailwind.config.js
with open("tailwind.config.js", "w") as tailwind_config:
    tailwind_config.write("module.exports = {\n")
    tailwind_config.write("  content: [\n")
    tailwind_config.write("    './resources/**/*.blade.php',\n")
    tailwind_config.write("    './resources/**/*.js',\n")
    tailwind_config.write("    './resources/**/*.vue',\n")
    tailwind_config.write("  ],\n")
    tailwind_config.write("  theme: {\n")
    tailwind_config.write("    extend: {},\n")
    tailwind_config.write("  },\n")
    tailwind_config.write("  plugins: [],\n")
    tailwind_config.write("}\n")

    # Dodanie trasy do pliku routes/web.php
with open("routes/web.php", "a") as web_routes:
    web_routes.write("\nRoute::get('/tailwind', function () {\n")
    web_routes.write("    return view('tailwindcss');\n")
    web_routes.write("});\n")

    # Utworzenie pliku widoku
os.makedirs("resources/views", exist_ok=True)
with open("resources/views/tailwindcss.blade.php", "w") as view_file:
    view_file.write("<!DOCTYPE html>\n")
    view_file.write("<html lang=\"en\">\n")
    view_file.write("<head>\n")
    view_file.write("    <meta charset=\"UTF-8\">\n")
    view_file.write("    <meta name=\"viewport\" content=\"width=device-width, initial-scale=1.0\">\n")
    view_file.write("    <title>Tailwind CSS View</title>\n")
    view_file.write("    @vite('resources/css/app.css')\n")
    view_file.write("</head>\n")
    view_file.write("<body>\n")
    view_file.write("    <div class=\"container mx-auto\">\n")
    view_file.write("        <h1 class=\"text-4xl font-bold text-blue-500\">Witaj w Tailwind CSS View!</h1>\n")
    view_file.write("        <p class=\"text-gray-700\">To jest przykładowy widok korzystający z Tailwind CSS.</p>\n")
    view_file.write("    </div>\n")
    view_file.write("</body>\n")
    view_file.write("</html>\n")

# Tworzenie pliku CSS
os.makedirs("resources/css", exist_ok=True)
with open("resources/css/app.css", "w") as css_file:
    css_file.write("@import 'tailwindcss/base';\n")
    css_file.write("@import 'tailwindcss/components';\n")
    css_file.write("@import 'tailwindcss/utilities';\n")

# Kompilacja i uruchamianie serwera developerskiego
os.system("npm run build")

os.system('clear')

print(f"\nTailwind CSS został pomyślnie zintegrowany z projektem Laravel. \nSprawdź działanie pod adresem: http://nazwadomeny.pl/tailwind\nSkrypt oraz jego akutalizacje dostępne na https://scriptmania.pl")